int bsym(char *s, int arity);   // return symbol number for built-in non-evaluable symbol  


#define ACOS 21    /* This should stay first--automode.c relies on it */
#define ACOT 22
#define ACSC 23
#define ASEC 24
#define ASIN 25
#define ATAN 26
#define SIN  27
#define COS  28
#define SEC  29
#define TAN  30
#define CSC  31
#define COT  32
#define SG   33
#define SQRT 34
#define LN   35
#define LOG  36
#define ABS  37
#define DET  38   /* determinant of a matrix */
#define SINH 39
#define COSH 40
#define TANH 41

#define FACTORIAL 46
#define FLOOR 48
#define NOT 49
#define REALPART 50
#define IMAGPART 51

#define BESSELJ 53
#define BESSELY 54
#define BESSELI 55
#define BESSELK 56    
#define GCD  57
#define BINOMIAL 59
#define BIGOH 91
#define MAXFUNCTOR 93 
/* 94 is '^', a literal functor */

#define MINFUNCTOR 123   /* for the function 'min' */
#define GE 124     /* Keep GE,LE,NE,MOD together and in this order */
#define LE 125
#define NE 126
#define MOD 127
#define IMPLIES 129    /*  -> when used as logical implication */
#define ARROW 129   /*   ->   when used in lim(x->0,f(x))  */
#define SEQ 130     /* not used in Mathpert, meant for theorem-proving */
#define DIFF 131
#define INTEGRAL 132
#define LOGB 133
#define IF   134
#define AND (unsigned short) 135
#define OR  (unsigned short) 136
#define ROOT 138
#define LIMIT 139
#define CASES 140
#define SUM 141       /* indexed sums */
#define PRODUCT 142   /* indexed products */
#define EVAL 143      /* as in evaluating f with respect to x from a to b,
                        used when evaluating definite integrals */
                     /* cannot be parsed, is only created by operators */
#define VECTOR 144    /* can't be bblocked or displayed */
#define POLY 151    /* for polynomials with all coefficients present, even zero ones*/
#define MATRIXMULT 152
#define MATRIX 153

/* Next the rest of the hyperbolic and inverse hyperbolic functions */

#define CSCH 154
#define SECH 155
#define COTH 156
#define ASINH 157
#define ACOSH 158
#define ATANH 159
#define ACSCH 160
#define ASECH 161
#define ACOTH 162

/* Now come the 'special functions'  (other than the Bessel functions, which
are listed above) */
#define GAMMA         163
#define DIGAMMA       164
#define ERF           165
#define ERFC          166
#define POLYGAMMA     167
#define COSINTEGRAL   168
#define LOGINTEGRAL   169
#define SININTEGRAL   170
#define EXPINTEGRALI  171
#define BETAFUNCTION  172  /* as opposed to atom BETA */
#define INCOMPLETEBETA 173
#define EXPINTEGRALE   174
#define INCOMPLETEGAMMA 175
#define INCOMPLETEGAMMAP 176
#define COMPLETE_ELLIPTIC1 177
#define COMPLETE_ELLIPTIC2 178
#define COMPLETE_ELLIPTIC3 179
#define ELLIPTICF          180
#define ELLIPTICE          181
#define ELLIPTICPI         182
#define EXISTS 183
#define FORALL 184
#define ALL    184
#define INFINITESIMAL 185
#define LAMBDA 186   /* for lambda abstraction;   */
#define AP 187    /* for lambda-calculus function application */
#define NUMERATOR 188   /* projection functions for RATIONAL -> INTEGER x NATNUM */
#define DENOM 189
#define CONSTANTOFINTEGRATION 190
#define RIEMANNZETA 191    /* parsed but not used */
#define SERIES 192
#define SETOF 193
#define WEIERSTRASSP 194   /* not actually used; should stay last in this list */
