/* M. Beeson, for MathXpert.
   Parser error messages in English
   Should be viewed and translated in ISO-Latin1 character set
   2.1.98 extracted from parser.c
   3.29.99 modified
   6.26.99 added 332 and 333
   6.29.04 added 334
   1.17.06  this copy moved to the ExternalSimp project associated with Otter-lambda
*/

#include <assert.h>

/*_________________________________________________________________*/
  const char * ParserErrorMessage(int err)
/*  returns a string to be printed to the screen in case of parsing error */
/*  input is the 'err' value returned by 'parse'  */
{  if( (259 <= err) && (err <= 277 ))
      return "Expression expected";
   switch (err)
    {
      case 256:  return "Logical expression must follow NOT";
      case 257:  return "Logical expression must follow logical OR";
      case 258:  return "Logical expression must follow logical AND";
      case 278:  return "Right parenthesis expected";
      case 279:  return "Right bracket expected";
      case 280:  return "Right brace expected";
      case 281:  return "Number expected";
      case 282:  return "Use parentheses before minus here";
      case 283:  return "Wrong number of arguments";
      case 284:  return "Can't understand function argument";
      case 285:  return "Can't understand exponent";
      case 294:  return "Open parentheses or bracket expected";
      case 295:  return "Expected more arguments";
      case 296:  return "Comma expected";
      case 297:  return "Right parenthesis expected";
      case 301:  return "Too large a decimal number";
      case 302:  return "Number too large";
      case 310:  return "Function argument expected";
      case 311:  return "Parentheses expected after function name";
      case 312:  return "Function name can have at most 31 characters";
      case 313:  return "Parentheses unbalanced";
      case 314:  return "Brackets unbalanced";
      case 315:  return "Braces unbalanced";
      case 316:  return "Can't understand this";
      case 317:  return "Nested braces that don't form a legal matrix";
      case 318:  return "Missing | to finish absolute value";
      case 319:  return "Second argument of sum must be a variable";
      case 320:  return "Can't understand function argument, try using parentheses";
      case 321:  return "Subscript too large -- may not exceed 1000";
      case 322:  return "Subscript on function must be a nonnegative integer";
      case 323:  return "Too many subscripted variables.";
      case 324:  return "Too many long variable names.";
      case 325:  return "Too many long function names.";
      case 326:  return "Inequality expected.";
      case 327:  return "Expecting an inequality or interval after 'if'.";
      case 328:  return "Semicolon can only be used after 'if' in a definition by cases.  Separate elements of a list by comma.";
      case 329:  return "Variable name too long.";
      case 330:  return "Type expected. The colon is used to specify the kind or 'type' of a variable.";
      case 331:  return "To enter a Greek letter or a symbol such as infinity, just type out the name, for example \"theta\".";
      case 332:  return "Integer expected as first argument of root";  /* don't translate 'root' */
      case 333:  return "Integer expected as first argument of Bessel function";
      case 334:  return "First argument of lambda must be a variable.";  /* Not needed for MathXpert */
      default:  assert(0);
    }
 return "illegal input";  /* avoid a warning message */
}

